// UPolevaultDialogs.cp

#ifndef __UPolevaultDIALOGS__
#include "UPolevaultDialogs.h"
#endif

#ifndef __UDOCUMENTPolevault__
#include "UDocumentPolevault.h"
#endif

#ifndef __AUXAESuite__
#include "AUXAESuite.h"
#endif

#ifndef TOOLUTILS
#include <ToolUtils.h>
#endif


//----------------------------------------------------------------------------------------
// PolevaultErrorBox: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal void PolevaultErrorBox(CStr255& theMessage, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{
	SubstituteDialogText(theMessage, param1, param2, param3);

	TWindow* theWindow = gViewServer->NewTemplateWindow(kErrorBox, NULL);
	FailNIL(theWindow);
	
	((TStaticText*)theWindow->FindSubView('MSGT'))->SetText(theMessage, TRUE);

	SysBeep(2);
	IDType dismisser = theWindow->PoseModally();
	switch(dismisser) {
		default:
			TCloseWindowCommand* aCCmd = new TCloseWindowCommand;
			aCCmd->ICloseWindowCommand(cClose, theWindow);
			theWindow->PostCommand(aCCmd);
			break;
	}	
}
//----------------------------------------------------------------------------------------
// PolevaultErrorBoxNumber: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal void PolevaultErrorBoxNumber(int theErrorNum, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{

	CStr255 theString;
	
	GetIndString(theString,kAlertUserToError  /*1001*/, theErrorNum);
	if (theString.IsEmpty())
		GetIndString(theString,kAlertUserToError  /*1001*/, kUnknownPolevaultError   /* 3 */);

	PolevaultErrorBox(theString, param1, param2, param3);
}
//----------------------------------------------------------------------------------------
// PolevaultInfoBoxNumber: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal void PolevaultInfoBoxNumber(int theErrorNum, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{

	CStr255 theString;
	
	GetIndString(theString,kAlertUserToError  /*1001*/, theErrorNum);
	if (theString.IsEmpty())
		GetIndString(theString,kAlertUserToError  /*1001*/, kUnknownPolevaultError   /* 3 */);

	PolevaultInfoBox(theString, param1, param2, param3);
}
//----------------------------------------------------------------------------------------
// PolevaultInfoBoxNumber: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal Boolean PolevaultConfirmBoxNumber(int theErrorNum, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{
	CStr255 theString; 
	
	GetIndString(theString,kAlertUserToError  /*1001*/, theErrorNum);
	if (theString.IsEmpty())
		GetIndString(theString,kAlertUserToError  /*1001*/, kUnknownPolevaultError   /* 3 */);

	return PolevaultConfirmBox(theString, param1, param2, param3);
}
//----------------------------------------------------------------------------------------
// PolevaultInfoBox: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal void PolevaultInfoBox(CStr255& theMessage, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{
	SubstituteDialogText(theMessage, param1, param2, param3);

	TWindow* theWindow = gViewServer->NewTemplateWindow(kInfoBox, NULL);
	FailNIL(theWindow);
	
	((TStaticText*)theWindow->FindSubView('MSGT'))->SetText(theMessage, TRUE);

	SysBeep(2);
	IDType dismisser = theWindow->PoseModally();
	switch(dismisser) {
		default:
			TCloseWindowCommand* aCCmd = new TCloseWindowCommand;
			aCCmd->ICloseWindowCommand(cClose, theWindow);
			theWindow->PostCommand(aCCmd);
			break;
		}	
}
//----------------------------------------------------------------------------------------
// PolevaultConfirmBox: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal Boolean PolevaultConfirmBox(CStr255& theMessage, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{
	SubstituteDialogText(theMessage, param1, param2, param3);
	
	TWindow* theWindow = gViewServer->NewTemplateWindow(kConfirmBox, NULL);
	FailNIL(theWindow);
	
	((TStaticText*)theWindow->FindSubView('MSGT'))->SetText(theMessage, TRUE);

	SysBeep(2);
	IDType dismisser = theWindow->PoseModally();
	TCloseWindowCommand* aCCmd = new TCloseWindowCommand;
	aCCmd->ICloseWindowCommand(cClose, theWindow);
	theWindow->PostCommand(aCCmd);
	switch(dismisser) {
		case 'OK  ':
			return TRUE;
		case 'CNCL':
			return FALSE;
		default:
			return FALSE;
	}	


}

//----------------------------------------------------------------------------------------
// SubstituteDialogText: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal void SubstituteDialogText(CStr255& theMessage, const CStr255& param1 ,
												const CStr255& param2 ,
												const CStr255& param3 )

{
	const CStr255	kParamText1 = "^0";
	const CStr255	kParamText2 = "^1";
	const CStr255	kParamText3 = "^2";
	short i = theMessage.Pos(kParamText1);
	if (i && !param1.IsEmpty())
		{

		theMessage.Delete(i, kParamText1.Length());
		theMessage.Insert(param1, i);
		}

	i = theMessage.Pos(kParamText2);
	if (i && !param2.IsEmpty())
		{

		theMessage.Delete(i, kParamText2.Length());
		theMessage.Insert(param2, i);
		}
	i = theMessage.Pos(kParamText3);
	if (i && !param3.IsEmpty())
		{

		theMessage.Delete(i, kParamText3.Length());
		theMessage.Insert(param3, i);
		}
}