/*
	UPolevaultView.h
	
	Copyright 1991 Apple Computer, Inc.
	All rights reserved

	Change History:
	
 */

#ifndef __UPOLEVAULTVIEW__
#define __UPOLEVAULTVIEW__

#ifndef __UVIEW__
#include <UView.h>
#endif

//----------------------------------------------------------------------------------------
// Forward and external classes (see Types.h for PascalObj macro)
//----------------------------------------------------------------------------------------

class PascalObj TDocumentPolevault;
class PascalObj TStream;

//----------------------------------------------------------------------------------------
// TPolevaultView
//----------------------------------------------------------------------------------------

class TPolevaultView: public TView
{
	public:
		TDocumentPolevault* fDocumentPolevault;
		Boolean fPaletteFixedYet;
		
		// Construction/Destruction
		virtual pascal void Initialize(); // Override
		
		virtual pascal void IPolevaultView(TDocumentPolevault* itsDocument,
											TView* itsSuperView,
											const VPoint& itsLocation,
											const VPoint& itsSize);
											
		virtual pascal void DoPostCreate(TDocument* itsDocument); // Override
							   
		// Drawing
		virtual pascal void Draw(const VRect& area); // Override
		
		// Commands
		virtual pascal void DoSetupMenus(); // Override
		
		virtual pascal void DoMenuCommand(CommandNumber aCommandNumber); // Override
		
		virtual pascal void DoMouseCommand(VPoint& theMouse,
									  TToolboxEvent* event,
									  CPoint hysteresis); // Override
};

//----------------------------------------------------------------------------------------
// Global initialization procedure
//----------------------------------------------------------------------------------------

extern pascal void InitUPolevaultView();
	// Call this routine at initialization time

#endif