/*
	UTrackerMandel.h
	
	Copyright 1991 Apple Computer, Inc.
	All rights reserved

	Change History:
	
 */

#ifndef __UTRACKERMandel__
#define __UTRACKERMandel__

#ifndef __UCOMMAND__
#include <UCommand.h>
#endif

//----------------------------------------------------------------------------------------
// Forward and external classes (see Types.h for PascalObj macro)
//----------------------------------------------------------------------------------------

class PascalObj TDocumentPolevault;		

//----------------------------------------------------------------------------------------
// TTrackerMandel
//----------------------------------------------------------------------------------------

class TTrackerMandel: public TTracker
{
	public:
		TDocumentPolevault* fDocument;
		
		// Construction/Destruction
		virtual pascal void Initialize(); // Override
			// Comment Required
			
		virtual pascal void ITrackerMandel(TDocumentPolevault* itsDocument,
											 TView* itsView,
											 TScroller* itsScroller,
											 const VPoint& itsMouse);
			// Comment Required
			
		// Commands			
		virtual pascal void DoIt(); // Override
			// Comment Required
			
		virtual pascal void UndoIt(); // Override
			// Comment Required
			
		virtual pascal void RedoIt(); // Override
		
		// Tracking
		virtual pascal void TrackFeedback(TrackPhase aTrackPhase,
										const VPoint& anchorPoint,
										const VPoint& previousPoint,
										const VPoint& nextPoint,
										Boolean mouseDidMove,
										Boolean turnItOn); // Override
			// Comment Required
			
		virtual pascal TTracker* TrackMouse(TrackPhase aTrackPhase,
											 VPoint& anchorPoint,
											 VPoint& previousPoint,
											 VPoint& nextPoint,
											 Boolean mouseDidMove); // Override
			// Comment Required
			
		virtual pascal void TrackConstrain(TrackPhase aTrackPhase,
										const VPoint& anchorPoint,
									  	const VPoint& previousPoint,
									    VPoint& nextPoint,
										Boolean mouseDidMove);

};

#endif